﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using BotDetect;
using BotDetect.Web.UI;
using Microsoft.SharePoint.WebPartPages;

namespace BotDetectWebPart
{
    [DefaultProperty("Text")]
    [ToolboxData("<{0}:BotDetectSimpleWebPart runat=server>")]
    public class BotDetectSimpleWebPart : WebPart

    {
        private TextBox _inputText;
        private Button _submitButton;
        private Label _messageLabel;
        private Captcha _captchaControl;

        protected override void CreateChildControls()
        {
            base.CreateChildControls();

            _captchaControl = new Captcha();
            _captchaControl.ID = "BotDetectCaptcha";

            _inputText = new TextBox();
            _inputText.ID = "InputText";

            _submitButton = new Button();
            _submitButton.ID = "SubmitButton";
            _submitButton.Text = "Validate";

            _submitButton.Click +=
              new EventHandler(submitButton_Click);

            _messageLabel = new Label();
            _messageLabel.ID = "MessageLabel";

            this.Controls.Add(_captchaControl);
            this.Controls.Add(_inputText);
            this.Controls.Add(_submitButton);
            this.Controls.Add(_messageLabel);
        }

        void submitButton_Click(object sender, EventArgs e)
        {
            string captchaText =
              ((TextBox)Controls[1]).Text.Trim().ToUpper();

            ((TextBox)Controls[1]).Text = null;

            if (_captchaControl.Validate(captchaText))
            {
                ((Label)Controls[3]).Text = "Success!";
            }
            else
            {
                ((Label)Controls[3]).Text = "Error!";
            }
        }
    }
}
